﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
Private MC As MqttClient
Private user As String = "xxx"
Private password As String = "yyy"
Private Instance As String = "drawers"
Private MyTopic As String
Private serializator As B4XSerializator
End Sub

Sub Service_Create
Dim ClientID As String
Dim MCO As MqttConnectOptions


	ClientID = Rnd(0, 999999999) & DateTime.Now 'create a unique id
	Log ("ClientID=" & ClientID)
	
	MC.Initialize("mqtt", "tcp://m20.cloudmqtt.com:11953", ClientID)
	MCO.Initialize(user, password)
	MC.Connect2(MCO)
	MyTopic = Instance & "/" & MC.ClientID
	Log ("mytopic=" & MyTopic)
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub mqtt_Connected (Success As Boolean)
	Log("mqtt_Connected")
	If Success = False Then
		Log("LastException=" & LastException)
	Else
		Log ("Connected")
		MC.Subscribe(Instance & "/#", 0)
		MC.Subscribe("last", 1)
	End If
End Sub

Private Sub mqtt_Disconnected
	Log("mqtt_Disconnected")
	
End Sub

Private Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Log("mqtt_MessageArrived=")
	
	Dim obj As Object = serializator.ConvertBytesToObject(Payload)
	'If obj Is CircleData Then
	'	Log ("CIRCLEDATA")
	'Else 'obj is string
		Dim Message As String = obj
		Log ("Message=" & Message)
	'End If
	
	Main.Message = Message
	CallSubDelayed(Main, "Receive")
	
	
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo(Message, Message, Main)
	n.Notify(1)
	
End Sub

Public Sub Send1 
	MC.Publish(MyTopic, serializator.ConvertObjectToBytes("SEND1") )
End Sub

Public Sub Send2 
	MC.Publish(MyTopic, serializator.ConvertObjectToBytes("SEND2") )
End Sub
